/*******************************************************************************
* implementierung des data encryption standards in c++
* proseminar kryptografie ws 01/02
* codierung eines 8-byte strings
* authors: christian osterrieder, 9821215
*          florian angulanza, 9715097
*******************************************************************************/

   class EncryptDES{
   
   private:
   
   //klassenvariable fuer debug-modus, ausgabe in datei
   //bei EnableDumpBin=1 wird file geschrieben
      static int enabledumpbin;
   
   //funktion zur ausgabe fr kontrolle in datei:
      static void dumpBin(char *str, int value);
      static void dumpBin(bool lin);
      static void dumpBin(char *str);
      static void dumpBin(char *str, bool *b, int bits);
   //erzeugen des rundenschluessels:
      static void computeRoundKey(bool roundkey[56], bool key[56]);
   //schluessel um 1 bit-pos. nach links verschieben:
      static void rotateRoundKeyLeft(bool roundkey[56]);
   //schluessel um 1 bit-pos. nach rechts verschieben:
      static void rotateRoundKeyRight(bool roundkey[56]);
    //erledigt p-box-permutation:
      static void computeP(bool output[32], bool input[32]);
   //durchfuehren der initialen permutation des blockes (eingangspermutation)
      static void computeIP(bool l[32], bool r[32], bool inBlk[64]);
   //durchfuehren der finalen permutation des blockes (ausgangspermutation)
      static void computeFP(bool outBlk[64], bool l[32], bool r[32]);
   //erweiterung (expansion) des teilblockes von 32 bit auf 48 bit,
   //XOR Verknuepfung der Werte, s-boxen anwenden, p-permutation anwenden:
      static void computeF(bool fout[32], bool r[32], bool roundkey[56]);
   //linken und rechten block tauschen fr neue verschluesselungsrunde:
      static void exchange_L_and_R(bool l[32], bool r[32]);
   //expansion eines blockes von 32 auf 48 bit
      static void computeExpansionE(bool expandedblock[48], bool r[32]);
   //anwendung der tabelle PC2
      static void computePC2(bool subkey[48], bool roundkey[56]);
   //ein bitfield in einen string umwandeln:
      static void bftostr (bool bitfield[64], char str[8]);
   //einen string in ein bitfield umwandeln:
      static void strtobf (bool bitfield[64], char str[8]);
   // funktion zum verschluesseln eines 64-Bit Blocks:
   // key[56]: eingabe eines 56-Bit Schluessels
   // outBlk[64]: ausgabe des verschluesselten 64-Bit Blocks
   // inBlk[64]: eingabe eines 64-Bit Klartextes
      static void encrypt(bool key[56], bool outblk[64], bool inblk[64]);
   // funktion zum verschluesseln eines 64-Bit Blocks:
   // key[56]: eingabe eines 56-Bit Schluessels
   // outBlk[64]: ausgabe des verschluesselten 64-Bit Blocks
   // inBlk[64]: eingabe eines 64-Bit Klartextes
      static void decrypt(bool key[56], bool outblk[64], bool inblk[64]);
   //reduziert 64-bit key in 56-bit key indem das parity-bit geloescht wird:
      static void reduceKey(bool realkey[56], bool bigkey[64]);
   //bitfelder in  8 x 6 bits aufteilen und doS_Box anwenden:
      static void computeS_Box(bool out[32], bool in[48]);
   //s-boxen anwenden:
      static void doS_Box(bool output[4], bool input[6], int boxnumber);
   
   public:
   // doDES gibt nach eingabe eines 8 Byte-Klartextwortes das verschluesselte
   // 8 Byte Wort aus.
   // input: der zu verschluesselnde string von 8 byte lnge
   // key: der schluessel von 8 byte lnge
   // output: der verschluesselte string von 8 byte lnge
   // debug: debug = 1 schreibt datei encryptDES.txt
      void doDES(char input[8], char key[8], char output[8], int debug);
      void doDES(char input[8], char key[8], char output[8]); //debug = off
   // undoDES gibt nach eingabe eines 8 Byte-Chiffrewortes das entschluesselte
   // 8 Byte Klartextwort aus.
   // input: der zu entschluesselnde string von 8 byte lnge
   // key: der schluessel von 8 byte lnge
   // output: der entschluesselte string von 8 byte lnge
   // debug: debug = 1 gibt entwicklung der ausgabe aus
      void undoDES(char input[8], char key[8], char output[8], int debug);
      void undoDES(char input[8], char key[8], char output[8]); //debug = off
   
   };
